/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "SDL.h"
#include "chopper.h"
#include "llist.h"

// create a new chopper that flies to the left
chopperl::chopperl(int x) : sprite(DATADIR, "/heli1.bmp")
{
  dst.x = x;
  dst.y = 100;
  dst.w = image->w;
  dst.h = image->h;
  black.w = image->w + 3;
  black.h = image->h + 3;
  black.x = dst.x - 3;
  black.y = dst.y - 3;
  points = 10;
  end = false;
}

// move the chopper "plane" a few pixels to the left
void chopperl::move(bool plane)
{
  //std::std::cout << "dst.x: " << dst.x << std::endl;
  if (dst.x < 0-image->w)
  {
    if (plane)
      return;
    dst.x = 800+image->w;
  }
  dst.x-=3;
  black.x = dst.x - 1;
}


// create a new chopper that flies to the right
chopperr::chopperr(int x) : sprite(DATADIR, "/heli2.bmp")
{
  dst.x = x;
  dst.y = 5;
  dst.w = image->w;
  dst.h = image->h;
  black.w = image->w + 6;
  black.h = image->h + 3;
  black.x = dst.x - 3;
  black.y = dst.y - 3;
  points = 10;
  end = false;
}

// move the chopper "plane" a few pixels to the right
void chopperr::move(bool plane)
{
  if (dst.x > 800)
  {
    if (plane)
      return;
    dst.x = 0-image->w;
  }
  dst.x+=3;
  black.x = dst.x - 3;
}

// moves the choppers
void move_choppers(SDL_Surface *screen, chopperl *chopperlar[NUM_OF_CHOP], chopperr *chopperrar[NUM_OF_CHOP], linkedList2 &troopLList, bool plane)
{
  for (int i=0;i<NUM_OF_CHOP;i++)
  {
  	trooper* troop = NULL;
  	SDL_Rect chopperltemp, chopperrtemp;
  	bool overlay, overlayr;
	chopperl *chopper = chopperlar[0];
  	chopperr *chopperr = chopperrar[0];
  	chopper = chopperlar[i];
	chopperr = chopperrar[i];
        if (!chopperlar[i])
        {
	  overlay = false;
	  for (int j=0;j<NUM_OF_CHOP;j++)
	  {
	    if (chopperlar[j] && ((((chopperlar[j]->getDstRect().x)+((chopperlar[j]->getSurface())->w)) >= 950) || (((chopperlar[j]->getDstRect().x) <= 137))))
              overlay = true;
	  }
	  if (!overlay && !plane)
	  {
	    chopperlar[i] = new chopperl(950);
            chopper = chopperlar[i];
	  }
        }
	if (chopper)// && (i == 0 || !chopperlar[i-1] || chopperlar[i-1]->getDstRect().x < 400))
	{
		chopperltemp = chopper->getDstRect();
		SDL_Rect chopperblack = chopper->getBlack();
		SDL_FillRect(screen, &chopperblack, SDL_MapRGB(screen->format, 0, 0, 0));
		SDL_BlitSurface(chopper->getSurface(), NULL, screen, &chopperltemp);
		if (chopper->drop_trooper())
		{
		  #ifdef DEBUG
		  std::cout << "Trooper dropped left: " << chopper->getDstRect().x << " : " << troopLList.getSize() << "\n\n\n";
		  #endif
                  troop = new trooper(chopper->getDstRect().x, chopper->getDstRect().y);
		  troopLList.add(troop);
		}
                chopper->move(plane);
		if (chopper->getEnd())
		{
			free(chopperlar[i]);
			chopperlar[i] = NULL;
		}
	}
        //if (!chopperr && ((chopperrar[i-1] && chopperrar[i-1]->getDstRect().x == 200) || (chopperrar[i+1] && chopperrar[i+1]->getDstRect().x == WIDTH-200)))
	if (!chopperrar[i])
        {
	  overlayr = false;
	  for (int j=0;j<NUM_OF_CHOP;j++)
	  {
	    if (chopperrar[j] && (((chopperrar[j]->getDstRect().x) >= -150 && (chopperrar[j]->getDstRect().x) <= 20)) || (chopperrar[j] && ((chopperrar[j]->getDstRect().x) >= 650)))
              overlayr = true;
	  }
	  if (!overlayr && !plane)
	  {
	    chopperrar[i] = new chopperr::chopperr(-150);
            chopperr = chopperrar[i];
	  }
        }
	if (chopperr)// && (i == 0 || !chopperrar[i-1] || chopperrar[i-1]->getDstRect().x > 300))
	{
		chopperrtemp = chopperr->getDstRect();
		SDL_Rect chopperblack = chopperr->getBlack();
		SDL_FillRect(screen, &chopperblack, SDL_MapRGB(screen->format, 0, 0, 0));
		SDL_BlitSurface(chopperr->getSurface(), NULL, screen, &chopperrtemp);
		if (chopperr->drop_trooper())
		{
		  #ifdef DEBUG
		  std::cout << "Trooper dropped right: " << chopperr->getDstRect().x << " : " << troopLList.getSize() << "\n\n\n";
		  #endif
                  troop = new trooper(chopperr->getDstRect().x, chopperr->getDstRect().y);
		  troopLList.add(troop);
		}
		chopperr->move(plane);
		if (chopperr->getEnd())
		{
			free(chopperrar[i]);
			chopperrar[i] = NULL;
		}
	}
  }
}
