/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "llist.h"

list::list(bullet *b)
{
  bul = b;
  next = NULL;
}

list::~list()
{
  free(bul);
}

linkedList::linkedList()
{
  start = NULL;
  linked = NULL;
  last = NULL;
  size = 0;
}

void linkedList::add(bullet *b)
{
  list *bul = new list(b);
  if (start == NULL)
  {
    linked = bul;
    start = linked;
  }
  else
    linked->next = bul;
    linked = bul;
  last = linked;
  size++;
}

bullet *linkedList::get(int el)
{
  if (el > size)
  {
    std::cout << "Index " << el << " bestaat niet in LList!\n";
    exit(1);
  }
  list *element = start;
  for (int i=0;i<el;i++)
  {
    if (element)
      element = element->next;
    else
      element = NULL;
  }
  if (element)
    return element->bul;
  else
    return NULL;
}

void linkedList::remove(int el)
{
  if (el > size)
  {
    std::cout << "Index " << el << " bestaat niet in LList!\n";
    exit(1);
  }
  list *element = start;
  list *prev = start;
  for (int i=0;i<el;i++)
  {
    prev = element;
    element = element->next;
  }
  if (element == start)
  {
    list *temp = start;
    start = start->next;
    free(temp);
  }
  else if (element == last)
  {
    list *temp = element;
    last = prev;
    prev->next = NULL;
    linked = last;
    free(temp);
  }
  else
  {
    list *temp = element;
    element = element->next;
    prev->next = element;
    free(temp);
  }
  size--;
}


list2::list2(trooper *t)
{
  troop = t;
  next = NULL;
}

list2::~list2()
{
  free(troop);
}

linkedList2::linkedList2()
{
  start = NULL;
  linked = NULL;
  last = NULL;
  size = 0;
}

void linkedList2::add(trooper *t)
{
  list2 *troop = new list2(t);
  if (start == NULL)
  {
    linked = troop;
    start = linked;
  }
  else
    linked->next = troop;
    linked = troop;
  last = linked;
  size++;
}

trooper *linkedList2::get(int el)
{
  if (el > size)
  {
    std::cout << "Index " << el << " bestaat niet in LList!\n";
    exit(1);
  }
  list2 *element = start;
  for (int i=0;i<el;i++)
  {
    if (element)
      element = element->next;
    else
    {
      std::cout << "\neerste check is NULL\n";
      element = NULL;
      //exit(1);
    }
  }
  if (element)
    return element->troop;
  else
  {
    std::cout << "\ntweede check is NULL\n";
    //exit(1);
    return NULL;
  }
}

void linkedList2::remove(int el)
{
  if (el > size)
  {
    std::cout << "Index " << el << " bestaat niet in LList!\n";
    exit(1);
  }
  list2 *element = start;
  list2 *prev = start;
  for (int i=0;i<el;i++)
  {
    prev = element;
    element = element->next;
  }
  if (element == start)
  {
    list2 *temp = start;
    start = start->next;
    free(temp);
  }
  else if (element == last)
  {
    list2 *temp = element;
    last = prev;
    prev->next = NULL;
    linked = last;
    free(temp);
  }
  else
  {
    list2 *temp = element;
    element = element->next;
    prev->next = element;
    free(temp);
  }
  size--;
}

void linkedList2::remove_from_list(int el)
{
  if (el > size)
  {
    std::cout << "Index " << el << " bestaat niet in LList!\n";
    exit(1);
  }
  list2 *element = start;
  list2 *prev = start;
  for (int i=0;i<el;i++)
  {
    prev = element;
    element = element->next;
  }
  if (element == start)
  {
    start = start->next;
  }
  else if (element == last)
  {
    last = prev;
    prev->next = NULL;
    linked = last;
  }
  else
  {
    element = element->next;
    prev->next = element;
    
  }
  size--;
}
