/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef LLIST_H
#define LLIST_H

#include <iostream>
#include "bullet.h"
#include "sprite.h"
//#include "trooper.h"

class trooper;

struct list
{
  bullet *bul;
  list *next;
  list(bullet *b);
  ~list();
};

class linkedList
{
  private:
    list *start;
    list *linked;
    list *last;
    int size;
    
  public:
    linkedList();
    void add(bullet *b);
    bullet *get(int el);
    int getSize(){return size;};
    void remove(int el);
    list *next(list *el){return el->next;};
};

struct list2
{
  trooper *troop;
  list2 *next;
  list2(trooper *t);
  ~list2();
};

class linkedList2
{
  private:
    list2 *start;
    list2 *linked;
    list2 *last;
    int size;
    
  public:
    linkedList2();
    void add(trooper *t);
    trooper *get(int el);
    int getSize(){return size;};
    void remove(int el);
    void remove_from_list(int el);
    list2 *next(list2 *el){return el->next;};
};

#endif
