/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef SPRITE_H
#define SPRITE_H

#include <iostream>
#include "SDL.h"

class sprite
{
  protected:
    SDL_Surface *image;
    SDL_Rect dst, black;

  public:
    sprite::sprite(char *path, const char *file)
    {
	char *temppath = new char[strlen(path)+strlen(file)+1];
	strcpy(temppath, path);
	temppath = strcat(temppath, file);
       //std::cout << "In sprite constructor\n";
       image = SDL_LoadBMP(temppath);
       delete temppath;
       temppath = NULL;
       //std::cout << "Na loadBMP\n";
       if (image == NULL)
       {
         std::cout << "Couldn't load " << path << file << std::endl;
         exit(1);
       }
       SDL_SetColorKey(image, SDL_SRCCOLORKEY, SDL_MapRGB(image->format, 255, 255, 0));
       //std::cout << "Uit sprite constructor\n";
    }
    sprite::~sprite()
    {
      //std::cout << "In sprite destructor\n";
      //SDL_FreeSurface(image);
    }
    SDL_Rect getDstRect() {return dst;};
    void setDstRect(SDL_Rect rect){dst = rect;};
    SDL_Surface *getSurface() {return image;};
    SDL_Rect getBlack() {return black;};
};
#endif
